// --Task-- Complete the Gouraud vertex shader
// When doing the calculations with points, make sure you are in the camera / eye coordinate space.
// The vertex positions and normals sent(by Three.js) to the vertex shader are initially in the local coordinate space.
// Three.js provides you with a modelViewMatrix(mat4) and a normalMatrix(mat3) for each vertex of each object.
// Those transform from the object space to camera space.

uniform vec3 lightPosition;
uniform vec3 color;
varying vec3 interpolatedColor;

void main() {
    // 1. Calculate the vertexPosition in the camera space.
    // 2. Calculate the correct normal in the camera space.
    // 3. Find the direction towards the viewer, normalize.
    // 4. Find the direction towards the light source, normalize.

    // Implement Phong's lighting/reflection model:
    //  - Ambient term you can just add
    //  - Use the values calculated before for the diffuse/Lambertian term
    //  - For Phong's specular, find the reflection of the light ray from the point
    //    See: https://www.opengl.org/sdk/docs/man/html/reflect.xhtml
    //    Use a value like 200 for the shininess

    interpolatedColor = color; // Replace this line

    gl_Position = projectionMatrix * modelViewMatrix * vec4(position, 1.0);
}